Index: java/main/src/main/java/com/framsticks/hosting/ClientAtServer.java
===================================================================
--- java/main/src/main/java/com/framsticks/hosting/ClientAtServer.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/hosting/ClientAtServer.java	(revision 100)
@@ -81,7 +81,7 @@
 		rootTree.getRegistry().registerAndBuild(CliEvent.class);
 
-		AccessInterface access = new PropertiesAccess(rootFramsClass);
-
-		root = access.createAccessee();
+		Access access = new PropertiesAccess(rootFramsClass);
+
+		root = createAccessee(rootTree, access);
 		access.select(root);
 		access.set(id, treeRootObject);
@@ -112,5 +112,5 @@
 	}
 
-	public static File printToFile(String path, AccessInterface access) {
+	public static File printToFile(String path, Access access) {
 		ListSink sink = new ListSink();
 		access.save(sink);
@@ -128,6 +128,6 @@
 				}
 
-				// final AccessInterface access = tree.prepareAccess(path);
-				final AccessInterface access = bindAccess(path);
+				// final Access access = tree.prepareAccess(path);
+				final Access access = bindAccess(path);
 
 				if (request instanceof GetRequest) {
Index: java/main/src/main/java/com/framsticks/hosting/Server.java
===================================================================
--- java/main/src/main/java/com/framsticks/hosting/Server.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/hosting/Server.java	(revision 100)
@@ -1,6 +1,7 @@
 package com.framsticks.hosting;
 
-import org.apache.log4j.Level;
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Level;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 import com.framsticks.core.Tree;
@@ -28,5 +29,5 @@
 public class Server extends AbstractJoinable implements JoinableParent {
 
-	private final static Logger log = Logger.getLogger(Server.class);
+	private final static Logger log = LogManager.getLogger(Server.class);
 
 	protected int port;
@@ -131,5 +132,5 @@
 					final Socket socket = acceptSocket.accept();
 					assert socket != null;
-					log.debug("accepted socket: " + socket.getInetAddress().getHostAddress());
+					log.debug("accepted socket: {}", socket.getInetAddress().getHostAddress());
 					hosted.dispatch(new RunAt<Tree>(this) {
 						@Override
@@ -137,9 +138,9 @@
 							ClientAtServer client = new ClientAtServer(Server.this, socket);
 							clients.add(client);
-							log.info("client connected: " + client);
+							log.info("client connected: {}", client);
 						}
 					});
 				} catch (IOException e) {
-					log.log((isRunning() ? Level.ERROR : Level.DEBUG), "failed to accept socket: " + e);
+					log.log((isRunning() ? Level.ERROR : Level.DEBUG), "failed to accept socket: {}", e);
 				}
 				acceptNext();
@@ -154,9 +155,9 @@
 				try {
 					acceptSocket.bind(new InetSocketAddress(port));
-					log.debug("started accepting on port " + port);
+					log.debug("started accepting on port {}", port);
 					acceptNext();
 					return;
 				} catch (IOException e) {
-					log.warn("failed to accept on port " + port + " (repeating): " + e);
+					log.warn("failed to accept on port {} (repeating): ", port, e);
 				}
 				tryBind(1000);
@@ -201,5 +202,5 @@
 	//	} catch (ClassNotFoundException ignored) {
 	//	} catch (ConstructionException e) {
-	//		log.error("failed to use info from cache: " + e);
+	//		log.error("failed to use info from cache: {}", e);
 	//	}
 
@@ -213,5 +214,5 @@
 	//	FramsClass framsClass = getInfoFromCache(path.getTop().getObject().getClass().getCanonicalName());
 	//	if (framsClass == null) {
-	//		log.error("failed to create frams class for: " + path.getTop().getObject().getClass());
+	//		log.error("failed to create frams class for: {}", path.getTop().getObject().getClass());
 	//		future.result(null, new Exception());
 	//		return;
Index: java/main/src/main/java/com/framsticks/model/Genotype.java
===================================================================
--- java/main/src/main/java/com/framsticks/model/Genotype.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/model/Genotype.java	(revision 100)
@@ -5,9 +5,9 @@
 
 
-// import org.apache.log4j.Logger;
+// import org.apache.logging.log4j.Logger;
 
 @FramsClassAnnotation
 public class Genotype extends Model {
-	// private final static Logger log = Logger.getLogger(Genotype.class);
+	// private final static Logger log = LogManager.getLogger(Genotype.class);
 
 	@ParamAnnotation
@@ -87,5 +87,5 @@
 	public double getStrsiz() { return getNumparts(); }
 	@ParamAnnotation
-	public void setStrsiz(double strsiz) { setNumparts(strsiz); }
+	public void setStrsiz(double strsiz) {}
 
 
@@ -93,5 +93,5 @@
 	public double getStrjoints() { return getNumjoints(); }
 	@ParamAnnotation
-	public void setStrjoints(double strjoints) { setNumjoints(strjoints); }
+	public void setStrjoints(double strjoints) {}
 
 
@@ -99,5 +99,5 @@
 	public double getNnsiz() { return getNumneurons(); }
 	@ParamAnnotation
-	public void setNnsiz(double nnsiz) { setNumneurons(nnsiz); }
+	public void setNnsiz(double nnsiz) {}
 
 
Index: java/main/src/main/java/com/framsticks/model/Model.java
===================================================================
--- java/main/src/main/java/com/framsticks/model/Model.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/model/Model.java	(revision 100)
@@ -3,5 +3,4 @@
 import com.framsticks.params.annotations.FramsClassAnnotation;
 import com.framsticks.params.annotations.ParamAnnotation;
-import com.framsticks.util.lang.Containers;
 
 import java.util.ArrayList;
@@ -48,9 +47,9 @@
 	//this is impossible to use, because numparts field is marked as readonly
 	@ParamAnnotation
-	public void setNumparts(double numparts) { Containers.resizeList(parts, (int) (double) numparts); }
+	public void setNumparts(double numparts) {}
 	@ParamAnnotation
-	public void setNumjoints(double numjoints) { Containers.resizeList(joints, (int)(double)numjoints); }
+	public void setNumjoints(double numjoints) {}
 	@ParamAnnotation
-	public void setNumneurons(double numneurons) { Containers.resizeList(neuroDefinitions, (int)(double)numneurons); }
+	public void setNumneurons(double numneurons) {}
 
 	public List<Part> getParts() { return parts; }
Index: java/main/src/main/java/com/framsticks/model/ModelBuilder.java
===================================================================
--- java/main/src/main/java/com/framsticks/model/ModelBuilder.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/model/ModelBuilder.java	(revision 100)
@@ -35,5 +35,5 @@
 			}
 			F0Parser parser = new F0Parser(schema, stream);
-			components.addAll(Util.stripAccessInterface(parser.parse(), ModelComponent.class));
+			components.addAll(Util.stripAccess(parser.parse(), ModelComponent.class));
 		}
 		return build();
Index: java/main/src/main/java/com/framsticks/params/Access.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/Access.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/params/Access.java	(revision 100)
@@ -0,0 +1,88 @@
+package com.framsticks.params;
+
+
+import com.framsticks.params.types.EventParam;
+import com.framsticks.params.types.ProcedureParam;
+
+
+/**
+ * The Interface Access. It's the most general class for storing data in
+ * framsticks. In descriptions of methods names "property" and "parameter" are
+ * synonyms.
+ *
+ * @author Jarek Szymczak <name.surname@gmail.com> (please replace name and
+ *         surname with my personal data)
+ */
+public interface Access {
+
+	Param getParam(int i);
+
+	Param getParam(String id);
+
+	String getId();
+
+	int getParamCount();
+
+	Object call(String id, Object[] arguments);
+
+	Object call(ProcedureParam param, Object[] arguments);
+
+	<T> T get(int i, Class<T> type);
+
+	<T> T get(String id, Class<T> type);
+
+	<T> T get(ValueParam param, Class<T> type);
+
+	<T> int set(int i, T value);
+
+	<T> int set(String id, T value);
+
+	<T> int set(ValueParam param, T value);
+
+	void reg(EventParam param, EventListener<?> listener);
+
+	void regRemove(EventParam param, EventListener<?> listener);
+
+	void setDefault(boolean numericOnly);
+
+	void setDefault(int i, boolean numericOnly);
+
+	void setMin();
+
+	void setMin(int i);
+
+	void setMax();
+
+	void setMax(int i);
+
+	void save(SinkInterface sink);
+
+	void load(SourceInterface stream);
+
+	/**
+	 * Removes all the properties values.
+	 */
+	void clearValues();
+
+	Access select(Object object);
+
+	Object getSelected();
+
+	Access cloneAccess() throws ConstructionException;
+
+	Object createAccessee();
+
+	Iterable<Param> getParams();
+
+	FramsClass getFramsClass();
+
+	void tryAutoAppend(Object object);
+
+	int getCompositeParamCount();
+
+	CompositeParam getCompositeParam(int number);
+
+	ParamBuilder buildParam(ParamBuilder builder);
+
+
+}
Index: java/main/src/main/java/com/framsticks/params/ArrayListAccess.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ArrayListAccess.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/params/ArrayListAccess.java	(revision 100)
@@ -9,4 +9,5 @@
 import java.util.List;
 import java.util.ListIterator;
+import static com.framsticks.params.SetStateFlags.*;
 
 /**
@@ -18,5 +19,5 @@
 
 
-	public ArrayListAccess(AccessInterface elementAccess) {
+	public ArrayListAccess(Access elementAccess) {
 		super(elementAccess);
 	}
@@ -76,8 +77,24 @@
 	@Override
 	public <T> int set(int i, T value) {
-		while (i >= list.size()) {
-			list.add(null);
+		if (value != null) {
+			while (i >= list.size()) {
+				list.add(null);
+			}
+			list.set(i, value);
+			return 0;
 		}
-		list.set(i, value);
+		if (i >= list.size()) {
+			return PSET_HITMAX;
+		}
+		list.remove(i);
+		// for (int j = i + 1; j < list.size(); ++j) {
+		//	if (list.get(j) != null) {
+		//		list.set(i, null);
+		//		return 0;
+		//	}
+		// }
+		// while (list.size() > i) {
+		//	list.remove(i);
+		// }
 		return 0;
 	}
@@ -107,5 +124,5 @@
 	@Override
 	public ArrayListAccess select(Object object) {
-		list = (List<Object>) object;
+		list = Util.selectObjectForAccess(this, object, List.class);
 		return this;
 	}
Index: java/main/src/main/java/com/framsticks/params/CompositeParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/CompositeParam.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/params/CompositeParam.java	(revision 100)
@@ -28,5 +28,5 @@
 	}
 
-	public abstract AccessInterface prepareAccessInterface(AccessInterface access);
+	public abstract Access prepareAccess(Access access);
 
 	public abstract String computeAccessId();
Index: java/main/src/main/java/com/framsticks/params/FramsClass.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/FramsClass.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/params/FramsClass.java	(revision 100)
@@ -13,5 +13,6 @@
 import javax.annotation.concurrent.Immutable;
 
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 /**
@@ -31,5 +32,5 @@
 public class FramsClass {
 
-	private final static Logger log = Logger.getLogger(FramsClass.class);
+	private final static Logger log = LogManager.getLogger(FramsClass.class);
 
 	protected final String id;
@@ -73,5 +74,5 @@
 		}
 
-		log.trace("created framsclass " + this);
+		log.trace("created framsclass {}", this);
 
 	}
Index: java/main/src/main/java/com/framsticks/params/FramsClassBuilder.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/FramsClassBuilder.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/params/FramsClassBuilder.java	(revision 100)
@@ -14,5 +14,6 @@
 import java.util.Map;
 
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 import com.framsticks.params.annotations.AutoAppendAnnotation;
@@ -29,5 +30,5 @@
 public class FramsClassBuilder implements Builder<FramsClass> {
 	private static final Logger log =
-		Logger.getLogger(FramsClassBuilder.class);
+		LogManager.getLogger(FramsClassBuilder.class);
 
 	public static String getName(FramsClassAnnotation fca, Class<?> javaClass) {
@@ -75,5 +76,5 @@
 			//TODO parametrize this
 			if (map) {
-				b.append(" name");
+				b.append(" uid");
 			}
 
@@ -224,5 +225,5 @@
 		}
 
-		log.debug("building for class " + javaClass);
+		log.debug("building for class {}", javaClass);
 
 		FramsClassAnnotation fca = javaClass.getAnnotation(FramsClassAnnotation.class);
Index: java/main/src/main/java/com/framsticks/params/ListAccess.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ListAccess.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/params/ListAccess.java	(revision 100)
@@ -7,16 +7,17 @@
 import com.framsticks.params.types.EventParam;
 import com.framsticks.params.types.ProcedureParam;
+import com.framsticks.util.UnimplementedException;
 
 /**
  * @author Piotr Sniegowski
  */
-public abstract class ListAccess implements AccessInterface {
+public abstract class ListAccess implements Access {
 
-	final AccessInterface elementAccess;
+	final Access elementAccess;
 	final String containedTypeName;
 
 	protected final ParamBuilder paramBuilder;
 
-	public ListAccess(AccessInterface elementAccess) {
+	public ListAccess(Access elementAccess) {
 		this.elementAccess = elementAccess;
 		this.containedTypeName = elementAccess.getId();
@@ -66,7 +67,8 @@
 	@Override
 	public void load(SourceInterface stream) {
+		throw new UnimplementedException().msg("load in list access");
 	}
 
-	public AccessInterface getElementAccess() {
+	public Access getElementAccess() {
 		return elementAccess;
 	}
@@ -120,3 +122,7 @@
 		return b.toString();
 	}
+
+	public CompositeParam prepareParamFor(String id) {
+		return paramBuilder.id(id).finish(CompositeParam.class);
+	}
 };
Index: java/main/src/main/java/com/framsticks/params/ParamBuilder.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ParamBuilder.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/params/ParamBuilder.java	(revision 100)
@@ -10,5 +10,6 @@
 import com.framsticks.util.lang.Strings;
 
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 import java.lang.reflect.InvocationTargetException;
@@ -32,5 +33,5 @@
 @FramsClassAnnotation(name = "prop", id = "prop")
 public class ParamBuilder implements Builder<Param> {
-	private final static Logger log = Logger.getLogger(ParamBuilder.class.getName());
+	private final static Logger log = LogManager.getLogger(ParamBuilder.class.getName());
 
 	private static final String ID_FIELD = "id";
@@ -265,5 +266,5 @@
 		assert type != null;
 
-		log.trace("parsing type: " + type);
+		log.trace("parsing type: {}", type);
 
 		String[] typeSplitted = type.split(" ");
@@ -301,5 +302,5 @@
 							}
 							default: {
-								log.error("unknown type: " + first);
+								log.error("unknown type: {}", first);
 								return this;
 							}
@@ -349,5 +350,5 @@
 		}
 		default: {
-			log.error("unknown type: " + first);
+			log.error("unknown type: {}", first);
 			return this;
 		}
@@ -445,6 +446,5 @@
 
 		if (paramEntryValues.length == 0) {
-			log.warn("field empty or wrong format (" + line
-					+ ") - omitting");
+			log.warn("field empty or wrong format ({}) - omitting", line);
 			return null;
 		}
@@ -464,6 +464,5 @@
 			/** everything is ok, parameters have just finished*/
 		} catch (NumberFormatException ex) {
-			log.warn("wrong format of entry: " + line
-					+ ", omitting");
+			log.warn("wrong format of entry: {}, omitting", line);
 			return null;
 		}
@@ -492,5 +491,5 @@
 				break;
 			default:
-				log.error("unknown field for Param: " + key);
+				log.error("unknown field for Param: {}", key);
 				break;
 		}
Index: java/main/src/main/java/com/framsticks/params/PropertiesAccess.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/PropertiesAccess.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/params/PropertiesAccess.java	(revision 100)
@@ -76,5 +76,5 @@
 	@Override
 	public PropertiesAccess select(Object object) {
-		this.properties = (Map<String, Object>)object;
+		properties = Util.selectObjectForAccess(this, object, Map.class);
 		return this;
 	}
@@ -116,3 +116,12 @@
 	}
 
+	@Override
+	public String toString() {
+		StringBuilder b = new StringBuilder();
+		b.append(framsClass);
+		if (getSelected() != null) {
+			b.append("(").append(getSelected().size()).append(")");
+		}
+		return b.toString();
+	}
 }
Index: java/main/src/main/java/com/framsticks/params/ReflectionAccess.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ReflectionAccess.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/params/ReflectionAccess.java	(revision 100)
@@ -14,5 +14,6 @@
 import javax.annotation.concurrent.Immutable;
 
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 import com.framsticks.params.annotations.AutoAppendAnnotation;
@@ -33,5 +34,5 @@
  */
 public class ReflectionAccess extends SimpleAbstractAccess {
-	private final static Logger log = Logger.getLogger(ReflectionAccess.class.getName());
+	private final static Logger log = LogManager.getLogger(ReflectionAccess.class.getName());
 
 	protected final Class<?> javaClass;
@@ -88,5 +89,5 @@
 			}
 
-			log.debug("constructing backend for " + id);
+			log.debug("constructing backend for {}", id);
 			backend = new Backend();
 
@@ -96,5 +97,5 @@
 				for (final ProcedureParam pp : filterInstanceof(framsClass.getParamEntries(), ProcedureParam.class)) {
 					if (!candidates.containsKey(pp.getId())) {
-						log.trace("java class does implement method " + pp);
+						log.trace("java class does implement method {}", pp);
 						continue;
 					}
@@ -114,5 +115,5 @@
 				for (final EventParam ep : filterInstanceof(framsClass.getParamEntries(), EventParam.class)) {
 					if (!candidates.containsKey(ep.getId())) {
-						log.trace("java class does not implement the event param " + ep);
+						log.trace("java class does not implement the event param {}", ep);
 						continue;
 					}
@@ -312,4 +313,7 @@
 				if (s == null) {
 					throw new FramsticksException().msg("trying to set unsettable");
+					// return;
+					// if (value != backend.getters.get(param).get(object, Object.class)) {
+					// }
 				}
 				s.set(object, value);
@@ -412,6 +416,5 @@
 	@Override
 	public ReflectionAccess select(Object object) {
-		assert object == null || javaClass.isInstance(object);
-		this.object = object;
+		this.object = Util.selectObjectForAccess(this, object, javaClass);
 		return this;
 	}
@@ -447,5 +450,5 @@
 			e.printStackTrace();
 		}
-		log.fatal("failed to create reflected object of class " + javaClass.getCanonicalName() + " for frams type " + framsClass.getId());
+		log.fatal("failed to create reflected object of class {} for frams type {}", javaClass.getCanonicalName(), framsClass.getId());
 		return null;
 	}
@@ -459,5 +462,5 @@
 				if (m.getParameterTypes()[0].isAssignableFrom(value.getClass())) {
 					try {
-						log.trace("auto appending with value " + value + " with method " + m);
+						log.trace("auto appending with value {} with method {}", value, m);
 						m.invoke(object, value);
 						return;
@@ -474,4 +477,13 @@
 	}
 
+	@Override
+	public String toString() {
+		StringBuilder b = new StringBuilder();
+		b.append(framsClass);
+		if (getSelected() != null) {
+			b.append("(").append(getSelected()).append(")");
+		}
+		return b.toString();
+	}
 }
 
Index: java/main/src/main/java/com/framsticks/params/Registry.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/Registry.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/params/Registry.java	(revision 100)
@@ -1,5 +1,6 @@
 package com.framsticks.params;
 
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 import com.framsticks.params.annotations.FramsClassAnnotation;
@@ -20,5 +21,5 @@
 @FramsClassAnnotation
 public class Registry {
-	private static final Logger log = Logger.getLogger(Registry.class.getName());
+	private static final Logger log = LogManager.getLogger(Registry.class.getName());
 
 	protected final DoubleMap<String, Class<?>> javaClasses = new DoubleMap<>();
@@ -84,5 +85,5 @@
 	}
 
-	public @Nonnull AccessInterface createAccess(String name, FramsClass framsClass) throws ConstructionException {
+	public @Nonnull Access createAccess(String name, FramsClass framsClass) throws ConstructionException {
 		// assert framsClasses.containsValue(framsClass);
 		if (javaClasses.containsKey(name)) {
@@ -93,7 +94,11 @@
 
 	public FramsClass putFramsClass(FramsClass framsClass) {
-		log.debug("caching info for " + framsClass);
+		log.debug("caching info for {}", framsClass);
 		framsClasses.put(framsClass.getId(), framsClass.getName(), framsClass);
 		return framsClass;
+	}
+
+	public FramsClass getFramsClass(@Nonnull CompositeParam param) {
+		return framsClasses.get(param.getContainedTypeName());
 	}
 
@@ -102,13 +107,13 @@
 	}
 
-	public static @Nonnull AccessInterface wrapAccessWithListIfNeeded(@Nonnull CompositeParam param, @Nonnull AccessInterface access) {
-		return param.prepareAccessInterface(access);
+	public static @Nonnull Access wrapAccessWithListIfNeeded(@Nonnull CompositeParam param, @Nonnull Access access) {
+		return param.prepareAccess(access);
 	}
 
-	public @Nonnull AccessInterface prepareAccess(CompositeParam param) throws ConstructionException {
+	public @Nonnull Access prepareAccess(CompositeParam param) throws ConstructionException {
 		return wrapAccessWithListIfNeeded(param, createAccess(param.getContainedTypeName()));
 	}
 
-	public @Nonnull AccessInterface createAccess(@Nonnull String name) throws ConstructionException {
+	public @Nonnull Access createAccess(@Nonnull String name) throws ConstructionException {
 		try {
 			Strings.assureNotEmpty(name);
Index: java/main/src/main/java/com/framsticks/params/SimpleAbstractAccess.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/SimpleAbstractAccess.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/params/SimpleAbstractAccess.java	(revision 100)
@@ -4,5 +4,6 @@
 import static com.framsticks.util.lang.Containers.filterInstanceof;
 
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 import com.framsticks.params.types.ObjectParam;
@@ -11,6 +12,6 @@
 
 /**
- * The Class SimpleAbstractAccess implements all the methods of AccessInterface
- * which actions can be implemented with usage of {@link AccessInterface} methods
+ * The Class SimpleAbstractAccess implements all the methods of Access
+ * which actions can be implemented with usage of {@link Access} methods
  * or concern schema, which is stored in {@link #framsClass}
  *
@@ -22,7 +23,7 @@
  * @author Piotr Sniegowski
  */
-public abstract class SimpleAbstractAccess implements AccessInterface {
-
-	private final static Logger log = Logger.getLogger(SimpleAbstractAccess.class.getName());
+public abstract class SimpleAbstractAccess implements Access {
+
+	private final static Logger log = LogManager.getLogger(SimpleAbstractAccess.class.getName());
 
 	protected final FramsClass framsClass;
@@ -190,11 +191,10 @@
 	}
 
-	private Entry readEntry(SourceInterface source) {
+	private static Entry readEntry(SourceInterface source) {
 
 		String line;
 		String key = null;
 		StringBuilder value = null;
-		while ((line = source.readLine()) != null)
-		{
+		while ((line = source.readLine()) != null) {
 			if (key == null) {
 				int colonIndex = line.indexOf(':');
@@ -216,19 +216,9 @@
 				value.append(System.getProperty("line.separator"));
 			}
-			if (line.contains("~")) {
-				value.append(line.substring(0, line.indexOf("~")));
-				return new Entry(key, value.toString());
+			if (line.endsWith("~") && !line.endsWith("\\~")) {
+				value.append(line.substring(0, line.length() - 1));
+				return new Entry(key, value.toString().replaceAll("\\\\~", "~"));
 			}
 			value.append(line);
-			/*
-			if (line.contains("~")) {
-				String lastLine = line.substring(0, line.indexOf("~"));
-				if (lastLine.length() > 0) {
-					appendToValue(value, lastLine);
-				}
-				return new Entry(key, value.toString());
-			}
-			appendToValue(value, line);
-			*/
 		}
 		return null;
@@ -244,17 +234,14 @@
 			Param param = getParam(entry.key);
 			if (param == null) {
-				continue;
+				throw new FramsticksException().msg("param not found in access").arg("name", entry.key).arg("access", this);
 			}
 			if (!(param instanceof ValueParam)) {
-				log.warn("param " + param + " is not a ValueParam");
-				continue;
-			}
-			if ((param.getFlags() & ParamFlags.DONTLOAD) != 0) {
-				log.debug("DontLoad flag was set - not loading...");
-			} else {
+				throw new FramsticksException().msg("param is not a value param").arg("param", param).arg("access", this);
+			}
+			if ((param.getFlags() & ParamFlags.DONTLOAD) == 0) {
 				int retFlags = this.set((ValueParam) param, entry.value);
 				if ((retFlags & (PSET_HITMIN | PSET_HITMAX)) != 0) {
 					String which = ((retFlags & PSET_HITMIN) != 0) ? "small" : "big";
-					log.warn("value of key '" + entry.key + "' was too " + which + ", adjusted");
+					log.warn("value of key '{}' was too {}, adjusted", entry.key, which);
 				}
 			}
@@ -297,13 +284,4 @@
 	}*/
 
-	@Override
-	public String toString() {
-		StringBuilder b = new StringBuilder();
-		b.append(framsClass);
-		if (getSelected() != null) {
-			b.append("(").append(getSelected()).append(")");
-		}
-		return b.toString();
-	}
 
 	@Override
Index: java/main/src/main/java/com/framsticks/params/UniqueListAccess.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/UniqueListAccess.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/params/UniqueListAccess.java	(revision 100)
@@ -7,5 +7,6 @@
 import com.framsticks.util.lang.Casting;
 import com.framsticks.util.lang.Numbers;
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 import java.util.*;
@@ -16,13 +17,15 @@
 public class UniqueListAccess extends ListAccess {
 
-	private static final Logger log = Logger.getLogger(UniqueListAccess.class);
+	private static final Logger log = LogManager.getLogger(UniqueListAccess.class);
 
 	Map<String, Object> map;
 
-	final String uidName;
-
-	public UniqueListAccess(AccessInterface elementAccess, String uidName) {
+	protected final String uidName;
+	protected final Access uidAccess;
+
+	public UniqueListAccess(Access elementAccess, String uidName) {
 		super(elementAccess);
 		this.uidName = uidName;
+		uidAccess = elementAccess.cloneAccess();
 	}
 
@@ -35,13 +38,21 @@
 	}
 
+	/**
+	 * @return the uidName
+	 */
+	public String getUidName() {
+		return uidName;
+	}
+
 	public static class UidComparator implements Comparator<String> {
 
-		protected String name;
+		protected Object description;
+
 
 		/**
-		 * @param name
+		 * @param description
 		 */
-		public UidComparator(String name) {
-			this.name = name;
+		public UidComparator(Object description) {
+			this.description = description;
 		}
 
@@ -65,13 +76,29 @@
 		@Override
 		public String toString() {
-			return "comparator " + name;
-		}
-
-
+			return "comparator " + description;
+		}
+
+
+	}
+
+	public static <T> Map<String, T> createMap(Class<T> type, Object description) {
+		return new TreeMap<String, T>(new UidComparator(description));
+	}
+
+	public static <M, T extends M> int getNumberInMap(Map<String, M> map, T object) {
+		Iterator<Map.Entry<String, M>> iterator = map.entrySet().iterator();
+		int number = 0;
+		while (iterator.hasNext()) {
+			if (iterator.next().getValue() == object) {
+				return number;
+			}
+			++number;
+		}
+		return -1;
 	}
 
 	@Override
 	public Map<String, Object> createAccessee() {
-		return new TreeMap<String, Object>(new UidComparator(elementAccess.toString()));
+		return createMap(Object.class, elementAccess);
 	}
 
@@ -92,5 +119,5 @@
 			return null;
 		}
-		return paramBuilder.id(getUidOf(iterator.next().getValue())).finish(CompositeParam.class);
+		return paramBuilder.id(iterator.next().getKey()).finish(CompositeParam.class);
 	}
 
@@ -110,4 +137,5 @@
 		return paramBuilder.id(id).finish(CompositeParam.class);
 	}
+
 
 	@Override
@@ -156,9 +184,5 @@
 
 	public String getUidOf(Object value) {
-		Object tmp = elementAccess.getSelected();
-		elementAccess.select(value);
-		String uid = elementAccess.get(uidName, String.class);
-		elementAccess.select(tmp);
-		return uid;
+		return uidAccess.select(value).get(uidName, String.class);
 	}
 
@@ -227,6 +251,5 @@
 	@Override
 	public UniqueListAccess select(Object object) {
-		assert (object instanceof Map);
-		map = (Map<String, Object>) object;
+		map = Util.selectObjectForAccess(this, object, Map.class);
 		return this;
 	}
@@ -242,12 +265,12 @@
 	}
 
-	public String computeIdentifierFor(Object selected) {
-		String uid = getUidOf(selected);
-		if (uid == null) {
-			log.error("missing uid field");
-			return null;
-		}
-		return uid;
-	}
+	// public String computeIdentifierFor(Object selected) {
+	//	String uid = getUidOf(selected);
+	//	if (uid == null) {
+	//		log.error("missing uid field");
+	//		return null;
+	//	}
+	//	return uid;
+	// }
 
 	@Override
